//-*-C++-*- Header file for the Config Class
// Copyright (C) 1997 by John P. Weiss
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the Artistic License, included as the file
// "LICENSE" in the source code archive.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//
// You should have received a copy of the file "LICENSE", containing
// the License John Weiss originally placed this program under.
//
// This file is unreadable, because the comment-docifier is
// brainedead.  Try a "make srcdocs" to generate the
// HTML-documentation.
//
#ifndef _Config_h_
#define _Config_h_
#include "APDialog.h"
#include <qchkbox.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlined.h>
#include <qpushbt.h>

//
#define STYLEFLAGS WStyle_Customize|WStyle_Title|WStyle_SysMenu
#define IOBUFLEN 256
#define BIGBUFLEN 1024
#define CDROM_DRIVENAME "/dev/cdrom"


/**
  An \Ref{APDialog} for configuration.

  I'm not documenting this one all that much, since I'm not satisifed
  with it.  Someday, I'll get back to this and improve it.  I don't
  have the time at the moment.

  If you want to change/replace this with something of your own,
  please do!  I ask only that you send me the patch.

  @memo Configuration panel.
  */
class Config : public APDialog
{
	 //
	 Q_OBJECT

   public:
	 Config(void);
	 ~Config(void);
	 //
	 char devname[IOBUFLEN],wmdbname[IOBUFLEN],tkdbname[IOBUFLEN];
	 bool hasTray,useIoctl,useWMDB,useTKDB;

         //
   public slots:
      /** 
           {\em Public Slot} {\tt [virtual]}

           Reimplemented from \Ref{APDialog}.
           @memo [{\tt virtual public slot}]
           */
         void open();

   private slots:
	 void setActiveICB(bool);
	 void setActiveWMFB(bool);
	 void setActiveTKFB(bool);
	 void setTrayFlg(bool);
	 void setIoctlFlg(bool);
	 void setWmFlg(bool);
	 void setTkFlg(bool);
	 void setStrDev();
	 void setStrWMDB();
	 void setStrTKDB();
	 void saveCfg();

   private:
	 QLabel *warntxt,*wmboxlbl,*tkboxlbl,*devboxlbl,*ioctlwarntxt;
	 QFrame *cdbox,*dbbox,*dbhbar;
	 QPushButton *closeb,*saveb;
	 QCheckBox *trayb,*ioctlb,*wmdb_b,*tkdb_b;
	 QLineEdit *devfile,*wmdbfile,*tkdbfile;
	 //
	 char cfgfile[BIGBUFLEN];
	 //
	 void createChildren(QFont df);
	 void connectChildren(void);
	 void readCfg(void);
};

#endif // _Config_h_
//||||||||||||||||||||||||||||||||
//
// End
// 
